<?php

namespace Chippyash\Test\Validation\Common;

use Chippyash\Validation\Messenger;

/**
 * Generated by PHPUnit_SkeletonGenerator 1.2.1 on 2013-11-05 at 13:37:47.
 */
class DoubleTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var \Chippyash\Validation\Common\Double
     */
    protected $sut;

    protected function setUp()
    {
        $this->sut = new \Chippyash\Validation\Common\Double();
    }

    /**
     * @dataProvider numbersToTest
     */
    public function testWillReturnCorrectResponseForTestDataSetViaMagicInvokeMethod($date, $result)
    {
        $messenger = new Messenger();
        $sut = $this->sut;
        $this->assertEquals($result, $sut($date, $messenger));
        if (!$result) {
            $this->assertEquals('Value is not a Double format', $messenger->implode());
        }
    }

    /**
     * @dataProvider numbersToTest
     */
    public function testWillReturnCorrectResponseForTestDataSetViaIsValidMethod($date, $result)
    {
        $this->assertEquals($result, $this->sut->isValid($date));
        if (!$result) {
            $this->assertEquals(
                'Value is not a Double format',
                implode(': ', $this->sut->getMessages()));
        }
    }

    public function numbersToTest()
    {
        return array(
            array(20.13, true),
            array(20, true),
            array('', false),
            array('three', false),
            array(4e5, true),
            array('+20.4', true),
        );
    }
}
